/*
 * Copyright (c) 2018 Logic Optimization Group @ UdL
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SUDOKU_IO_H_
#define _SUDOKU_IO_H_

#include <stdio.h>


/**
 *
 */
typedef struct
{
    int n_cols;
    int n_rows;
    int n_cells;
    int n_values;

    int region_n_cols;
    int region_n_rows;

    int n_fixed_cells;

    int **cells;
} Sudoku;

enum ErrorCode;

/**
 *
 */
Sudoku* sudoku_new();

/**
 *
 */
int sudoku_init(Sudoku*, int region_n_cols, int region_n_rows);

/**
 *
 */
void sudoku_delete(Sudoku* sudoku);

/**
 *
 */
int sudoku_parse_file(const char* path, Sudoku* sudoku);

/**
 *
 */
const char* sudoku_translate_error_code(int error_code);

/**
 *
 */
void sudoku_print(FILE* outf, const Sudoku* sudoku);

#endif
